local on = true
local off = false

NA_Defaults = {
Guild = on, -- Enable on guild channel
Party = on, -- Enable on party channel
Say = on,  -- Enable for people near you
BGs = on,
Raid = on,
Yell = on,
Emotes = on,
Chats = on,
ChatDebug = on,
CustomMP3 = off,
CustomOGG = off,
--
-- Addon Output Settings
MSBT = on,  -- Output achievement to Mik's Scrolling Battle Text
Sound = on, -- Enable Sound Output
--
-- Addon State
Enable = on -- enable/disable the addon 
}

NA_DefaultsPC = {
RanOnce = false --Per char ran more than once
}

NA_Settings = {}
NA_SettingsPC = {}
NA_ChatFilter = {}

NA_NN = {} -- Nicknames
local NA -- Alias for NA_NN[Realm]


NickAlert = {}

NickAlert.Frame = CreateFrame("Frame")
NickAlert.Frame:RegisterEvent("ADDON_LOADED")
NickAlert.Frame:RegisterEvent("CHAT_MSG_BATTLEGROUND") -- arg1 chat message arg2 author 
NickAlert.Frame:RegisterEvent("CHAT_MSG_BATTLEGROUND_LEADER")
NickAlert.Frame:RegisterEvent("CHAT_MSG_CHANNEL") -- arg9 channel name without number (this is _sometimes_ in lowercase) 
NickAlert.Frame:RegisterEvent("CHAT_MSG_EMOTE")
NickAlert.Frame:RegisterEvent("CHAT_MSG_GUILD")
NickAlert.Frame:RegisterEvent("CHAT_MSG_OFFICER")
NickAlert.Frame:RegisterEvent("CHAT_MSG_PARTY")
NickAlert.Frame:RegisterEvent("CHAT_MSG_PARTY_LEADER")
NickAlert.Frame:RegisterEvent("CHAT_MSG_RAID")
NickAlert.Frame:RegisterEvent("CHAT_MSG_RAID_LEADER")
NickAlert.Frame:RegisterEvent("CHAT_MSG_RAID_WARNING")
NickAlert.Frame:RegisterEvent("CHAT_MSG_SAY")
NickAlert.Frame:RegisterEvent("CHAT_MSG_TEXT_EMOTE")
NickAlert.Frame:RegisterEvent("CHAT_MSG_YELL")


-- Local text colors
local yel = "|cFFFFFF00"
local wht = "|cFFFFFFFF"
local blu = "|cFF00FFFF"
local red = "|cFFFF0000"
local grn = "|cFF00FF00"
local res = "|r"

local function addOptionMt(options, defaults)
	setmetatable(options, {__index = defaults})
	for i, v in pairs(options) do
		if type(v) == "table" and not getmetatable(v) then
			addOptionMt(v, defaults[i])
		end
	end
end

local SJprint = function(...)
	print( string.join(" ", ...))
end

NickAlert.StatColor = function(stat)
	if (stat == on) then
		return "|cFF00FF00[on]"
	elseif (stat == off) then
		return "|cFFFF0000[off]"
	end
	return stat
end


NickAlert.Frame:SetScript("OnEvent",function(self, event, ...)
	arg = ...
	if event == "ADDON_LOADED" and arg == "NickAlert" then
		SJprint(grn, "Nick Alert loaded", res)
		addOptionMt( NA_Settings , NA_Defaults )
		addOptionMt( NA_SettingsPC , NA_DefaultsPC )
		
		local realm = GetRealmName()
		local set = false
		
		if #NA_NN > 0 then
			for x = 1, #NA_NN do
				if NA_NN[x].Realm == realm then
					NA = NA_NN[x]
					set = true
				end
			end
		end
		
		if #NA_NN == nil and not(set) then
			NA_NN[1] = { Nicks = {}, Realm = realm}
			NA = NA_NN[1]
			set = true
		end
		
		if not(set) then
			local index = #NA_NN + 1
			NA_NN[index] = { Nicks = {}, Realm = realm} 
			NA = NA_NN[index]
		end
		
		if not(NA_SettingsPC.RanOnce) then
			SJprint(yel, "\n\nNick Alert", res)
			SJprint(yel, " Please set nicknames for this char.", res)
			SJprint(yel, " Your current char name will be automatically added to the list", res)
			print("\n\n")
			NickAlert.NickNames(string.join(" ","add",GetUnitName("player")))
			NA_SettingsPC.RanOnce = true
		end
		
		return self, event, ...
	end
	
	if not(NA_Settings.Enable) then
		return
	end
	
	
	local args = {...}
	local color = {255,255,255}
	local msg = args[1]
	local name = args[2]
	local mode = ""
	local R,G,B = 255, 255, 255
	local match = false
	
	if name == UnitName("player") then
		return
	end
	
	for x = 1, #NA.Nicks do
		if string.find(string.lower(msg), string.lower(NA.Nicks[x])) then
			match = true
		end
	end
	
	if not(match) then
		return
	end
	
	if event == "CHAT_MSG_BATTLEGROUND" and NA_Settings.BGs then -- arg1 chat message arg2 author 
		mode = "BG"
		R,G,B = 255, 153, 0
	elseif event == "CHAT_MSG_BATTLEGROUND_LEADER" and NA_Settings.BGs then 
		mode = "BG"
		R,G,B = 255, 51, 0
	elseif event == "CHAT_MSG_CHANNEL" and NA_Settings.Chats then  -- arg9 channel name without number (this is _sometimes_ in lowercase) 
		mode = args[9]
		R,G,B = 255, 255, 255
	elseif event == "CHAT_MSG_EMOTE" and NA_Settings.Emotes then 
		mode = "EMOTE"
		R,G,B = 255, 153, 51
	elseif event == "CHAT_MSG_GUILD" and NA_Settings.Guild then
		mode = "GUILD"
		R,G,B = 0, 255, 0
	elseif event == "CHAT_MSG_OFFICER" and NA_Settings.Guild then
		mode = "OFFICER"
		R,G,B = 0, 128, 0
	elseif event == "CHAT_MSG_PARTY" and NA_Settings.Party then 
		mode = "PARTY"
		R,G,B = 0, 255, 255
	elseif event == "CHAT_MSG_PARTY_LEADER" and NA_Settings.Party then 
		mode = "PARTY"
		R,G,B = 0, 170, 170
	elseif event == "CHAT_MSG_RAID" and NA_Settings.Raid then
		mode = "RAID"
		R,G,B = 255, 153, 0
	elseif event == "CHAT_MSG_RAID_LEADER" and NA_Settings.Raid then 
		mode = "RAID"
		R,G,B = 255, 51, 0
	elseif event == "CHAT_MSG_RAID_WARNING" and NA_Settings.Raid then
		mode = "RAIDWARNING"
		R,G,B = 255, 0, 51
	elseif event == "CHAT_MSG_SAY" and NA_Settings.Say then
		mode = "SAY"
		R,G,B = 255, 255, 255
	elseif event == "CHAT_MSG_TEXT_EMOTE" and NA_Settings.Emotes then
		mode = "EMOTE"
		R,G,B = 255, 153, 51
	elseif event == "CHAT_MSG_YELL" and NA_Settings.Yells then
		mode = "YELL"
		R,G,B = 255, 0, 0
	else
		return
	end
	
	local output = string.join(" ", mode, name, ":", msg)
	
	if NA_Settings.ChatDebug then
		print( output )
	end
	
	if #NA_ChatFilter > 0 then
		for x = 1, #NA_ChatFilter do
			if string.find( string.lower(mode) , string.lower(NA_ChatFilter[x]) )then
				return
			end
		end
	end
	
	if NA_Settings.MSBT and IsAddOnLoaded("MikScrollingBattleText") then
		if not(MikSBT.IsModDisabled()) then
			MikSBT.DisplayMessage( output , MikSBT.DISPLAYTYPE_NOTIFICATION, true, R, G, B)
		end
	end

	if NA_Settings.Sound then
		if NA_Settings.CustomMP3 then
			PlaySoundFile("Interface\\AddOns\\NickAlert\\alert.mp3")
		elseif NA_Settings.CustomOGG then
			PlaySoundFile("Interface\\AddOns\\NickAlert\\alert.ogg")
		else
			PlaySound("READYCHECK")
		end
	end
end)


NickAlert.NickNames = function( msg )
	local cmd, arg, arg2 = string.split(" ", msg)
	local nick = arg
	cmd = string.lower(cmd)
	
	if cmd == "on" or cmd == "off" then
		NA_Settings.Enable = (cmd == "on")
		SJprint( yel, "Nick Alert: Addon is", NickAlert.StatColor( NA_Settings.Enable ), res)
		return
	end

	if not(NA_Settings.Enable) then
		SJprint( yel, "Nick Alert: The addon is disabled type \"", blu, "/nalert on", yel, "to enable", res)
		return
	end
	
	if cmd == "" then
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Nick Alert:", res)
		SJprint( yel, "  Addon is", NickAlert.StatColor( NA_Settings.Enable ), res)
		SJprint( blu, "     Guild", wht, "is", NickAlert.StatColor( NA_Settings.Guild ), res)
		SJprint( blu, "     Party", wht, "is", NickAlert.StatColor( NA_Settings.Party ), res)
		SJprint( blu, "     Say", wht, "is", NickAlert.StatColor( NA_Settings.Say ), res)
		SJprint( blu, "     BGs", wht, "is", NickAlert.StatColor( NA_Settings.BGs ), res)
		SJprint( blu, "     Raid", wht, "is", NickAlert.StatColor( NA_Settings.Raid ), res)
		SJprint( blu, "     Yell", wht, "is", NickAlert.StatColor( NA_Settings.Yell ), res)
		SJprint( blu, "     Emotes", wht, "is", NickAlert.StatColor( NA_Settings.Emotes ), res)
		SJprint( blu, "     Chats", wht, "is", NickAlert.StatColor( NA_Settings.Chats ), res)
		SJprint( blu, "     ChatDebug", wht, "is", NickAlert.StatColor( NA_Settings.ChatDebug ), res)
		SJprint( blu, "     MSBT", wht, "is", NickAlert.StatColor( NA_Settings.MSBT ), res)
		SJprint( blu, "     Sound", wht, "is", NickAlert.StatColor( NA_Settings.Sound ), res)
		SJprint( blu, "     CustomMP3", wht, "is", NickAlert.StatColor(NA_Settings.CustomMP3), res)
		SJprint( blu, "     CustomOGG", wht, "is", NickAlert.StatColor(NA_Settings.CustomOGG), res)
		print(" ")
		SJprint( yel, #NA.Nicks, "nicknames are stored for this server.")
		return
	end
	

	if cmd == "guild" then
		if arg == "on" or arg == "off" then
			NA_Settings.Guild = (arg == "on")
		end
		SJprint( yel, "Nick Alert: Guild is", NickAlert.StatColor( NA_Settings.Guild ), res)
		return
	end
	
	if cmd == "party" then
		if arg == "on" or arg == "off" then
			NA_Settings.Party = (arg == "on")
		end
		SJprint( yel, "Nick Alert: Party is", NickAlert.StatColor( NA_Settings.Party ), res)
		return
	end

	if cmd == "say" then
		if arg == "on" or arg == "off" then
			NA_Settings.Say = (arg == "on")
		end
		SJprint( yel, "Nick Alert: Say is", NickAlert.StatColor( NA_Settings.Say ), res)
		return
	end
	
	if cmd == "BGs" then
		if arg == "on" or arg == "off" then
			NA_Settings.BGs = (arg == "on")
		end
		SJprint( yel, "Nick Alert: BGs is", NickAlert.StatColor( NA_Settings.BGs ), res)
		return
	end
	
	if cmd == "raid" then
		if arg == "on" or arg == "off" then
			NA_Settings.Raid = (arg == "on")
		end
		SJprint( yel, "Nick Alert: Raid is", NickAlert.StatColor( NA_Settings.Raid ), res)
		return
	end
	
	if cmd == "yell" then
		if arg == "on" or arg == "off" then
			NA_Settings.Yell = (arg == "on")
		end
		SJprint( yel, "Nick Alert: Yell is", NickAlert.StatColor( NA_Settings.Yell ), res)
		return
	end
	
	if cmd == "emotes" then
		if arg == "on" or arg == "off" then
			NA_Settings.Emotes = (arg == "on")
		end
		SJprint( yel, "Nick Alert: Emotes is", NickAlert.StatColor( NA_Settings.Emotes ), res)
		return
	end
	
	if cmd == "chats" then
		if arg == "on" or arg == "off" then
			NA_Settings.Chats = (arg == "on")
		end
		SJprint( yel, "Nick Alert: Chats is", NickAlert.StatColor( NA_Settings.Chats ), res)
		return
	end
	
	if cmd == "chatdebug" then
		if arg == "on" or arg == "off" then
			NA_Settings.ChatDebug = (arg == "on")
		end
		SJprint( yel, "Nick Alert: ChatDebug is", NickAlert.StatColor( NA_Settings.ChatDebug ), res)
		return
	end
	
	if cmd == "msbt" then
		if arg == "on" or arg == "off" then
			NA_Settings.MSBT = (arg == "on")
		end
		SJprint( yel, "Nick Alert: MSBT is", NickAlert.StatColor( NA_Settings.MSBT ), res)
		return
	end
	
	if cmd == "sound" then
		if arg == "on" or arg == "off" then
			NA_Settings.Sound = (arg == "on")
		end
		SJprint( yel, "Nick Alert: Sound is", NickAlert.StatColor( NA_Settings.Sound ), res)
		return
	end
	
	if cmd == "add" then
		local set = false
		
		if nick == nil then
			SJprint( yel, " Nick Alert: Nick Name entry error \n \"/nalert add NICKNAME\"", res)
			return
		end
	
		if #NA.Nicks > 0 then
			for x = 1, #NA.Nicks do
				if NA.Nicks[x] == nick then
					set = true
				end
			end
		end
	
		if not(set) then
			local index
			if #NA.Nicks == nil then
				index = 1
			else
				index = #NA.Nicks + 1
			end
			NA.Nicks[index] = nick
		end

		SJprint( yel, " Nick Alert: Nickname stored as NICKNAME:", nick , res)
		table.sort(NA.Nicks)
		return
	end

	if cmd == "rem" then
		local rem = false
		local number = tonumber(nick)
		
		if name == nil then
			SJprint( yel, " Nick Alert: Nick Name entry error \n \"/nalert rem NICK \"", res)
			return
		end
	
		if #NA.Nicks > 0 and number == nil then
			for x = 1, #NA.Nicks do
				if NA.Nicks[x] == nick then
					table.remove(NA.Nicks, x)
					rem = true
				end
			end
		end
		
		if number > 0 and number <= #NA.Nicks then
			nick = NA.Nicks[number]
			table.remove(NA.Nicks, number)
			rem = true
		end
		
		if not(rem) then
			SJprint( yel, " Nick Alert: Error \n Unable to find NICK:", nick, " to remove from nickname list", res)
		else
			SJprint( yel, " Nick Alert: NICK:", nick, " removed from nickname list", res)
		end
		return	
	end
	
	if cmd == "display" then
		SJprint( yel, "________________________________________", res)
		SJprint( yel, "Nick Alert", res)
		SJprint( yel, "  Nick Names List", res)
		SJprint( yel, "#  NICK:", res)
		if #NA.Nicks > 0 then
			for x = 1, #NA.Nicks do
				SJprint( yel, x, "  ", NA.Nicks[x], "\n", res)
			end
			SJprint( yel, #NA.Nicks, "Nicknames stored for this server", res)
		else
			SJprint( yel, "ERROR: No Nicknames Stored", res)
		end
		return
	end
	
	if cmd == "filter" then
		local subcmd = arg
		local filter = arg2
		
		if subcmd == "add" then
			local set = false
		
			if filter == nil then
				SJprint( yel, " Nick Alert: Filter entry error \n \"/nalert filter add CHANNEL\"", res)
				SJprint( yel, " CHANNEL = Channel name or part of name (e.g. Crb = Carbonite Channel Prefix", res)
				return
			end
	
			if #NA_ChatFilter > 0 then
				for x = 1, #NA_ChatFilter do
					if NA_ChatFilter[x] == filter then
					set = true
					end
				end
			end
			
			if not(set) then
				local index
				if #NA_ChatFilter == nil then
					index = 1
				else
					index = #NA_ChatFilter + 1
				end
				NA_ChatFilter[index] = filter
			end

			SJprint( yel, " Nick Alert: Filter stored as:", filter  , res)
			table.sort(NA_ChatFilter)
			return
		end

		if subcmd == "rem" then
			local rem = false
			local number = tonumber(nick)
		
			if filter == nil then
				SJprint( yel, " Nick Alert: Filter entry error \n \"/nalert filter rem FILTER\"", res)
				SJprint( yel, " FILTER = Existing filter as entered or number from DISPLAY", res)
				return
			end
	
			if #NA_ChatFilter > 0 and number == nil then
				for x = 1, #NA_ChatFilter do
					if NA_ChatFilter[x] == filter then
						table.remove(NA_ChatFilter, x)
						rem = true
					end
				end
			end
		
			if number > 0 and number <= #NA_ChatFilter then
				filter = NA_ChatFilter[number]
				table.remove(NA_ChatFilter, number)
				rem = true
			end
		
			if not(rem) then
				SJprint( yel, " Nick Alert: Error \n Unable to find FILTER:", filter, " to remove from the filter list", res)
			else
				SJprint( yel, " Nick Alert: FILTER:", filter, " removed from channel filter list", res)
			end
			return	
		end
	
		if (subcmd == "display") then
			SJprint( yel, "________________________________________", res)
			SJprint( yel, "Nick Alert", res)
			SJprint( yel, "  Channel Filter List", res)
			SJprint( yel, "#  FILTER:", res)
			if #NA_ChatFilter > 0 then
				for x = 1, #NA_ChatFilter do
					SJprint( yel, x, " ", NA_ChatFilter[x], "\n", res)
				end
				SJprint( yel, #NA_ChatFilter, "filters stored", res)
			else
				SJprint( yel, "ERROR: No filters stored", res)
			end
			return
		end

	end

	if cmd == "custommp3" then
		if arg == "on" or arg == "off" then
			NA_Settings.CustomMP3 = ( arg == "on" )
		end
		SJprint( yel, "Nick Alert: CustomMP3 is", NickAlert.StatColor( NA_Settings.CustomMP3 ), res)
		return
	end
	
	if cmd == "customogg" then
		if arg == "on" or arg == "off" then
			NA_Settings.CustomOGG = (arg == "on")
		end
		SJprint( yel, "Nick Alert: CustomOGG is", NickAlert.StatColor( NA_Settings.CustomOGG ), res)
		return
	end

	SJprint( yel, "________________________________________", res)
	SJprint( yel, "Nick Alert:", res)
	SJprint( blu, "  /nalert cmd", res)
	SJprint( red, cmd, yel, "is not a valid command", res)
	SJprint( yel, "  Commands are:", res)
	SJprint( blu, "     on", yel, "/", blu, "off", wht, "Turns Nick Names on and off", res)
	SJprint( blu, "     Guild", yel, "Enable nick scanning in guild channels [on / off]", res)
	SJprint( blu, "     Party", yel, "Enable nick scanning in party channel [on / off]", res)
	SJprint( blu, "     Say", yel, "Enable nick scanning in say channel [on / off]", res)
	SJprint( blu, "     BGs", yel, "Enable nick scanning in BattleGrounds [on / off]", res)
	SJprint( blu, "     Raid", yel, "Enable nick scanning in Raid Channels [on / off]", res)
	SJprint( blu, "     Yell", yel, "Enable nick scanning in Yells [on / off]", res)
	SJprint( blu, "     Emotes", yel, "Enable nick scanning in Emotes [on / off]", res)
	SJprint( blu, "     Chats", yel, "Enable nick scanning in general chat channels [on / off]", res)
	SJprint( blu, "     Filter", yel, "Filter chat channels like ones made by Carbonite \"/nalert filter\" for more info", res)
	SJprint( blu, "     MSBT", yel, "Enable output to MikScrollingBattleText if installed [on / off]", res)
	SJprint( blu, "     Sound", yel, "Enable sound when a nick match is found [on / off]", res)
	SJprint( blu, "     CustomMP3", yel, "Enable custom alert.mp3 sound when a nick match is found [on / off]", res)
	SJprint( blu, "     CustomOGG", yel, "Enable custom alert.ogg sound when a nick match is found [on / off]", res)
	SJprint( blu, "     add", yel, "Adds a nickname \"/nalert add NICKNAME\"", res)
	SJprint( blu, "     rem", yel, "Removes a nickname \"/nalert rem NICKNAME\" or \"/nalert rem NUMBER\" (number from DISPLAY)", res)
	SJprint( blu, "     display", yel, "Displays list of saved nicknames", res)
	print(" ")
	SJprint( yel, "Nick Alert:  Addon is", NickAlert.StatColor( NA_Settings.Enable ), res)
	SJprint( yel, "and ", #NA.Nicks, "nicknames are stored for this server.", res)
	return
end


SLASH_NALERT1 = "/nalert"
SlashCmdList["NALERT"] = function(msg)
	NickAlert.NickNames(msg)
end
